JSON Proof Algorithms
Internet-Draft draft-ietf-jose-json-proof-algorithms-05
Jeremie Miller
Ping Identity
jmiller@pingidentity.com
Michael B. Jones
Self-Issued Consulting
michael_b_jones@hotmail.com
https://self-issued.info/
David Waite
Ping Identity
dwaite+jwp@pingidentity.com
Internet
jose
jose
zkp
jwp
jws
jpa
The JSON Proof Algorithms (JPA) specification registers cryptographic algorithms and identifiers to be used with the JSON Web Proof and JSON Web Key (JWK) specifications. It defines IANA registries for these identifiers.
Introduction
The JSON Web Proof (JWP) [I-D.ietf-jose-json-web-proof] draft establishes a new secure container format that supports selective disclosure and unlinkability using Zero-Knowledge Proofs (ZKPs) or other cryptographic algorithms.
Editor's Note: This draft is still early and incomplete. There will be significant changes to the algorithms as currently defined here. Please do not use any of these definitions or examples for anything except personal experimentation and learning. Contributions and feedback are welcomed at https://github.com/json-web-proofs/json-web-proofs.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The roles of "issuer", "holder", and "verifier" are used as defined by the VC Data Model [VC-DATA-MODEL-2.0]. The term "presentation" is also used as defined by this source, but the term "credential" is avoided in this specification to minimize confusion with other definitions.
Terminology
The terms "JSON Web Signature (JWS)", "Base64url Encoding", "Header Parameter", "JOSE Header", "JWS Payload", "JWS Signature", and "JWS Protected Header" are defined by [RFC7515].
The terms "JSON Web Proof (JWP)", "JWP Payload", "JWP Proof", and "JWP Protected Header" are defined by [I-D.ietf-jose-json-web-proof].
These terms are defined by this specification:
Stable Key:
An asymmetric key-pair used by an issuer that is also shared via an out-of-band mechanism to a verifier to validate the signature.
Ephemeral Key:
An asymmetric key-pair that is generated for one-time use by an issuer and never stored or used again outside of the creation of a single JWP.
Presentation Key:
An asymmetric key-pair that is generated by a holder and used to ensure that a presentation is not able to be replayed by any other party.
Background
JWP defines a container binding together a protected header, one or more payloads, and a cryptographic proof. It does not define any details about the interactions between an application and the cryptographic libraries that implement proof-supporting algorithms.
Due to the nature of ZKPs, this specification also documents the subtle but important differences in proof algorithms versus those defined by the JSON Web Algorithms [RFC7518]. These differences help support more advanced capabilities such as blinded signatures and predicate proofs.
Algorithm Basics
The four principal interactions that every proof algorithm MUST support are [issue](#issue), [confirm](#confirm), [present](#present), and [verify](#verify).
Issue
The JWP is first created as the output of a JPA's issue operation.
Every algorithm MUST support a JSON issuer protected header along with one or more octet string payloads. The algorithm MAY support using additional items provided by the holder for issuance such as blinded payloads, keys for replay prevention, etc.
All algorithms MUST provide integrity protection for the issuer header and all payloads and MUST specify all digest and/or hash2curve methods used.
Confirm
Performed by the holder to validate that the issued JWP is correctly formed and protected.
Each algorithm MAY support using additional input items options, such as those sent to the issuer for issuance. After confirmation, an algorithm MAY return a modified JWP for serialized storage without the local state (such as with blinded payloads now unblinded).
The algorithm MUST fully verify the issued proof value against the issuer protected header and all payloads. If given a presented JWP instead of an issued one, the confirm process MUST return an error.
Present
Used to apply any selective disclosure choices and perform any unlinkability transformations, as well as to show binding.
An algorithm MAY support additional input options from the requesting party, such as for predicate proofs and verifiable computation requests.
Every algorithm MUST support the ability to hide any or all payloads. It MUST always include the issuer protected header unmodified in the presentation.
The algorithm MUST replace the issued proof value and generate a new presented proof value. It also MUST include a new presentation protected header that provides replay protection.
Verify
Performed by the verifier to verify the protected headers along with any disclosed payloads and/or assertions about them from the proving party, while also verifying they are the same payloads and ordering as witnessed by the issuer.
The algorithm MUST verify the integrity of all disclosed payloads and MUST also verify the integrity of both the issuer and presentation protected headers.
If the presented proof contains any assertions about the hidden payloads, the algorithm MUST also verify all of those assertions. It MAY support additional options, such as those sent to the holder to generate the presentation.
If given an issued JWP for verification, the algorithm MUST return an error.
Algorithm Specifications
This section defines how to use specific algorithms for JWPs.
Single Use
The Single Use (SU) algorithm is based on composing multiple traditional asymmetric signatures into a single JWP proof. It enables a very simple form of selective disclosure without requiring any advanced cryptographic techniques.
It does not support unlinkability if the same JWP is presented multiple times, therefore when privacy is required the holder will need to interact with the issuer again to receive new single-use JWPs (dynamically or in batches).
JWS Algorithm
The Single Use algorithm is based on using multiple signatures to cover the individual payloads, all of which are generated with the same Asymmetric JSON Web Algorithm (JWA). The internal signing algorithm to use is part of the registration for a new Single Use algorithm identifier.
The chosen JWA MUST be an asymmetric signing algorithm so that each signature can be verified without sharing any private values between the parties. This ensures that the verifier cannot brute force any non-disclosed payloads based only on their disclosed individual signatures.
Holder Setup
In order to support the protection of a presentation by a holder to a verifier, the holder MUST use a Presentation Key during the issuance and the presentation of every Single Use JWP. This Presentation Key MUST be generated and used for only one JWP.
The issuer MUST verify that the holder has possession of this key. The holder-issuer communication to exchange this information is out of scope of this specification, but can be accomplished by the holder using this key to generate a JWS that signs a value the issuer can verify as unique.
Issuer Setup
To create a Single Use JWP, the issuer first generates a unique Ephemeral Key using the selected internal algorithm. This key-pair will be used to sign each of the payloads of a single JWP and then discarded.
Signing payloads
Each individual payload is signed using the selected internal algorithm using the Ephemeral Key.
Issuer Protected Header
The JWK of the issuer's Ephemeral Key MUST be included in the issuer protected header with the property name of proof_jwk and contain only the REQUIRED values to represent the public key.
The holder's Presentation Key JWK MUST be included in issuer protected header using the presentation_jwk parameter.
The issuer protected header is signed using the given JWA and the issuer's Stable Key.
Payloads
Each JWP payload is processed in order and signed using the given JWA using the issuer's Ephemeral Key.
Proof
The proof value is an octet string array. The first entry is the octet string of the issuer protected header signature, with an additional entry for each payload signature.
Presentation Protected Header
To generate a new presentation, the holder first creates a presentation protected header that is specific to the verifier being presented to. This header MUST contain a parameter that both the holder and verifier trust as being unique and non-replayable. Use of the nonce header parameter is RECOMMENDED for this purpose.
This specification registers the nonce header parameter for the presentation protected header that contains a string value either generated by the verifier or derived from values provided by the verifier. When present, the verifier MUST ensure the nonce value matches during verification.
The presentation protected header MAY contain other header parameters that are either provided by the verifier or by the holder. These presentation header parameters SHOULD NOT contain values that are common across multiple presentations and SHOULD be unique to a single presentation and verifier.
In various examples in this specification, the octet string serialized presentation header is referenced as presentation_header.
Presentation
Editor's Note: The current definition here is incomplete, the holder's signature needs to also incorporate the presented proof.
The holder derives a new proof as part of presentation. The presented proof value will always contain the issuer's Stable Key signature for the issuer protected header as the first element.
The second element of the presented proof is the holder's signature of the presentation protected header using the holder's presentation key. This signature is constructed using the same algorithm described in generating the issuer's signature over the issuer protected header. Signing only the presentation header with the Presentation Key is sufficient to protect the entire presentation since that key is private to the holder and only the contents of the presentation header are used for replay prevention.
For each payload which is to be disclosed, the corresponding payload signature (from the issued JWP) is included in the proof. If a payload is omitted from the presented JWP, the signature value will NOT be includeed, and the presentation proof will have one less part.
For example, if the second and fifth of five payloads are not disclosed, then the holder's derived proof would consist of the issuer's signature over the issuer protected header, the holder's signature over the holder's protected header, the ephemeral key signature over the first, third and fourth payloads.
Since the individual signatures in the proof value are unique and remain unchanged across multiple presentations, a Single Use JWP SHOULD only be presented a single time to each verifier in order for the holder to remain unlinkable across multiple presentations.
Verification
The verifier MUST verify the issuer protected header octets against the first part in the proof using the issuer's Stable Key. It MUST also verify the presentation protected header octets against the second part in the proof value using the holder's Presentation Key, as provided in the presentation_jwk claim in the issuer protected header.
With the headers verified, the issuer's Ephemeral Key as given in the issuer protected header proof_jwk parameter can then be used to verify each of the disclosed payload signatures.
JPA Registration
The proposed JWP alg value is of the format "SU-" appended with the relevant JWS alg value for the chosen public and ephemeral key-pair algorithm, for example "SU-ES256".
BBS
The BBS Signature Scheme [I-D.irtf-cfrg-bbs-signatures] is under active development within the CRFG.
This algorithm supports both selective disclosure and unlinkability, enabling the holder to generate multiple presentations from one issued JWP without a verifier being able to correlate those presentations together based on the proof.
JPA Algorithms
The BBS alg parameter value in the issuance protected header corresponds to a ciphersuite identifier of BBS_BLS12381G1_XMD:SHA-256_SSWU_RO_.
The BBS-PROOF alg parameter value in the presentation protected header corresponds to the same ciphersuite, but used in presentation form.
Key Format
The key used for the BBS algorithm is an elliptic curve-based key pair, specifically against the G_2 subgroup of a pairing friendly curve. Additional details on key generation can be found in Section 3.4
The JWK form of this key is an OKP type with a curve of BLS12381G2, with x being the base64url-encoded form of the output of point_to_octets_E2. The use of this curve is described in [I-D.ietf-cose-bls-key-representations].
There is no additional holder key necessary for presentation proofs.
Issuance
Issuance is performed using the Sign operation from Section 3.5.1 of [I-D.irtf-cfrg-bbs-signatures]. This operation utilizes the issuer's BLS12-381 G2 key pair as SK and PK, along with desired protected header and payloads as the octets header and the octets array messages.
The octets resulting from this operation form a single octet string in the issuance proof array, to be used along with the protected header and payloads to serialize the JWP.
Issuance Proof Verification
Holder verification of the signature on issuance form is performed using the Verify operation from Section 3.5.2 of [I-D.irtf-cfrg-bbs-signatures].
This operation utilizes the issuer's public key as PK, the proof as signature, the protected header octets as header and the array of payload octets as messages.
Presentation
Derivation of a presentation is done by the holder using the ProofGen operation from Section 3.5.3 of [I-D.irtf-cfrg-bbs-signatures].
This operation utilizes the issuer's public key as PK, the issuer protected header as header, the issuance proof as signature, the issuance payloads as messages, and the holder's presentation protected header as ph.
The operation also takes a vector of indexes into messages, describing which payloads the holder wishes to disclose. All payloads are required for proof generation, but only these indicated payloads will be required to be disclosed for later proof verification.
The output of this operation is the presentation proof, as a single octet string.
Presentation serialization leverages the two protected headers and presentation proof, along with the disclosed payloads. Non-disclosed payloads are represented with the absent value of null in JSON serialization and a zero-length string in compact serialization.
Presentation Verification
Verification of a presentation is done by the verifier using the ProofVerify operation from Section 3.5.4.
This operation utilizes the issuer's public key as PK, the issuer protected header as header, the issuance proof as signature, the holder's presentation protected header as ph, and the payloads as disclosed_messages.
In addition, the disclosed_indexes scalar array is calculated from the payloads provided. Values disclosed in the presented payloads have a zero-based index in this array, while the indices of absent payloads are omitted.
Message Authentication Code
The Message Authentication Code (MAC) JPA uses a MAC to both generate ephemeral keys and compute authentication codes to protect the issuer header and each payload individually.
Like the the Single Use algorithm family, it also does not support unlinkability if the same JWP is presented multiple times. and requires an individually issued JWP for each presentation in order to fully protect privacy. When compared to the JWS approach, using a MAC requires less computation but can result in potentially larger presentation proof values.
The design is intentionally minimal and only involves using a single standardized MAC method instead of a mix of MAC/hash methods or a custom hash-based construct. It is able to use any published cryptographic MAC method such as HMAC [RFC2104] or KMAC. It uses traditional public-key based signatures to verify the authenticity of the issuer and holder.
Holder Setup
Prior to the issuer creating a new JWP, it must have presentation binding information provided by the holder. This enables the holder to perform replay prevention while presenting the JWP.
The presentation key used by the holder must be transferred to the issuer and verified, likely through a challenge and self-signing mechanism. If the holder requires unlinkability, it must also generate a new key that is verified and bound to each new JWP.
How these holder presentation keys are transferred and verified is out of scope of this specification. Protocols such as OpenID Connect can be used to accomplish this. What is required by this definition is that the holder's presentation key MUST be included in the issuer's protected header using the pjwk parameter with a JWK as the value.
Issuer Setup
To use the MAC algorithm, the issuer must have a stable public key pair to perform signing. To start the issuance process, a single 32-byte random Shared Secret must first be generated. This value will be shared privately to the holder as part of the issuer's JWP proof value.
The Shared Secret is used by both the issuer and holder as the MAC method's key to generate a new set of unique ephemeral keys. These keys are then used as the input to generate a MAC that protects each payload.
Issuer Protected Header
The holder's presentation key JWK MUST be included in the issuer protected header using the pjwk parameter. The issuer MUST validate that the holder has possession of this key through a trusted mechanism such as verifying the signature of a unique nonce value from the holder.
Combined MAC Representation
The combined MAC representation is a single octet string representing the MAC values of the issuer protected header, along with each payload provided by the issuer. This representation is signed by the issuer, but not shared - parties will recreate this octet string and verify the signature to verify the integrity of supplied issuer protected header and the integrity of any disclosed payloads.
The issuer protected header is included in this value as a MAC created using the fixed key "issuer_header" in UTF-8 encoded octets. The value is the issuer header JSON as a UTF-8 encoded octet string.
A unique key is generated for each payload using a MAC, with the Shared Secret as the key and a value of "payload_X" as UTF-8 encoded octets, where "X" is replaced by the zero-based array index of the payload, for example "payload_0", "payload_1", etc.
Each payload then itself has a corresponding MAC, using the above per-payload key and the payload octet string.
The combined MAC representation is the octet string formed by the the concatentation of the issuer protected header MAC output, along with each payload MAC output.
Issuer Proof
The issuer proof consists of two octet strings.
The first octet string is the issuer signature over the combined MAC representation. The issuer signs the JWS using its stable public key, and a fixed header containing the alg associated with signing algorithm in use.
jws_header = '{"alg":"ES256"}'
The signature value of the JWS is extracted and base64url-decoded into an octet string.
The second octet string is the Shared Secret used to generate the per-payload keys for the combined representation.
Presentation Protected Header
See the JWS Presentation Protected Header section.
Presentation Proof
Editor's Note: The current definition here is incomplete, the holder's signature needs to also incorporate the presented proof.
The first value in the presentation proof is the presentation signature. This is a signature over the presentation protected header, using the key specified by the pjwk parameter in the issuer protected header.
The second value is the issuer signature over the Combined MAC Representation provided with the issued form.
The remaining values are used by the verifier to reconstruct the combined MAC representation without access to the Shared Secret. There is one value corresponding to each payload, whether it has been disclosed or not.
If a payload is disclosed, the unique per-payload key derived from the shared secret is used as the payload's entry in the proof array.
If a payload is not disclosed, the payload's MAC in the combined MAC representation is used as the payload's entry in the proof array.
Verification of the Presentation Proof
The verifier must recreate the Combined MAC Representation from the presentation proof to verify integrity over the disclosed information.
The issuer protected header MAC is recreated using the same mechanism described above.
For each payload in the presentation:
- If the payload is disclosed, then the presentation proof contains the unique per-payload key. The corresponding payload MAC can be computed by performing the MAC operation with this key and the corresponding payload.
- If the payload is not disclosed, then the presentation proof contains the payload MAC, which can be used directly
The concatenation of the octets of the issuer protected header MAC and each payload MAC forms the Combined MAC Representation. The issuer signature in the proof is then verified by converting these values to a JWS as described above, and verifying that JWS.
JPA Registration
Proposed JWP alg value is of the format "MAC-" appended with a unique identifier for the set of MAC and signing algorithms used. Below are the initial registrations:
- MAC-H256 uses HMAC SHA-256 as the MAC and ECDSA using P-256 and SHA-256 for the signatures
- MAC-H384 uses HMAC SHA-384 as the MAC and ECDSA using P-384 and SHA-384 for the signatures
- MAC-H512 uses HMAC SHA-512 as the MAC and ECDSA using P-521 and SHA-512 for the signatures
- MAC-K25519 uses KMAC SHAKE128 as the MAC and EdDSA using Curve25519 for the signatures
- MAC-K448 uses KMAC SHAKE256 as the MAC and EdDSA using Curve448 for the signatures
- MAC-H256K uses HMAC SHA-256 as the MAC and ECDSA using secp256k1 and SHA-256 for the signatures
Security Considerations
Editor's Note: This will follow once the algorithms defined here have become more stable.
- Data minimization of the proof value
- Unlinkability of the protected header contents
IANA Considerations
The following registration procedure is used for all the registries established by this specification.
Values are registered on a Specification Required [RFC5226] basis after a three-week review period on the jose-reg-review@ietf.org mailing list, on the advice of one or more Designated Experts. However, to allow for the allocation of values prior to publication, the Designated Experts may approve registration once they are satisfied that such a specification will be published.
Registration requests sent to the mailing list for review should use an appropriate subject (e.g., "Request to register JWP algorithm: example").
Within the review period, the Designated Experts will either approve or deny the registration request, communicating this decision to the review list and IANA. Denials should include an explanation and, if applicable, suggestions as to how to make the request successful. Registration requests that are undetermined for a period longer than 21 days can be brought to the IESG's attention (using the iesg@ietf.org mailing list) for resolution.
Criteria that should be applied by the Designated Experts include determining whether the proposed registration duplicates existing functionality, whether it is likely to be of general applicability or useful only for a single application, and whether the registration description is clear.
IANA must only accept registry updates from the Designated Experts and should direct all requests for registration to the review mailing list.
It is suggested that multiple Designated Experts be appointed who are able to represent the perspectives of different applications using this specification, in order to enable broadly informed review of registration decisions. In cases where a registration decision could be perceived as creating a conflict of interest for a particular Expert, that Expert should defer to the judgment of the other Experts.
JSON Web Proof Algorithms Registry
This specification establishes the IANA "JSON Web Proof Algorithms" registry for values of the JWP alg (algorithm) parameter in JWP Header Parameters. The registry records the algorithm name, the algorithm description, the algorithm usage locations, the implementation requirements, the change controller, and a reference to the specification that defines it. The same algorithm name can be registered multiple times, provided that the sets of usage locations are disjoint.
It is suggested that the length of the key be included in the algorithm name when multiple variations of algorithms are being registered that use keys of different lengths and the key lengths for each need to be fixed (for instance, because they will be created by key derivation functions). This allows readers of the JSON text to more easily make security decisions.
The Designated Experts should perform reasonable due diligence that algorithms being registered either are currently considered cryptographically credible or are being registered as Deprecated or Prohibited.
The implementation requirements of an algorithm may be changed over time as the cryptographic landscape evolves, for instance, to change the status of an algorithm to Deprecated or to change the status of an algorithm from Optional to Recommended+ or Required. Changes of implementation requirements are only permitted on a Specification Required basis after review by the Designated Experts, with the new specification defining the revised implementation requirements level.
Registration Template
- Algorithm Name: The name requested (e.g., "SU-ES256"). This name is a case-sensitive ASCII string. Names may not match other registered names in a case-insensitive manner unless the Designated Experts state that there is a compelling reason to allow an exception.
- Algorithm Description: Brief description of the algorithm (e.g., "Single-Use JWP using ES256").
- Algorithm Usage Location(s): The algorithm usage locations, which should be one or more of the values Issued or Presented. Other values may be used with the approval of a Designated Expert.
- JWP Implementation Requirements: The algorithm implementation requirements for JWP, which must be one the words Required, Recommended, Optional, Deprecated, or Prohibited. Optionally, the word can be followed by a "+" or "-". The use of "+" indicates that the requirement strength is likely to be increased in a future version of the specification. The use of "-" indicates that the requirement strength is likely to be decreased in a future version of the specification. Any identifiers registered for non-authenticated encryption algorithms or other algorithms that are otherwise unsuitable for direct use as JWP algorithms must be registered as "Prohibited".
- Change Controller: For Standards Track RFCs, list the "IETF". For others, give the name of the responsible party. Other details (e.g., postal address, email address, home page URI) may also be included.
- Specification Document(s): Reference to the document or documents that specify the parameter, preferably including URIs that can be used to retrieve copies of the documents. An indication of the relevant sections may also be included but is not required.
- Algorithm Analysis Documents(s): References to a publication or publications in well-known cryptographic conferences, by national standards bodies, or by other authoritative sources analyzing the cryptographic soundness of the algorithm to be registered. The Designated Experts may require convincing evidence of the cryptographic soundness of a new algorithm to be provided with the registration request unless the algorithm is being registered as Deprecated or Prohibited. Having gone through working group and IETF review, the initial registrations made by this document are exempt from the need to provide this information.
Initial Registry Contents
- Algorithm Name: SU-ES256
- Algorithm Description: Single-Use JWP using ES256
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Recommended
- Change Controller: IETF
- Specification Document(s): Section 6.1.11 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: SU-ES384
- Algorithm Description: Single-Use JWP using ES384
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.1.11 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: SU-ES512
- Algorithm Description: Single-Use JWP using ES512
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.1.11 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: BBS
- Algorithm Description: Corresponds to a ciphersuite identifier of BBS_BLS12381G1_XMD:SHA-256_SSWU_RO_H2G_HM2S_
- Algorithm Usage Location(s): Issued
- JWP Implementation Requirements: Required
- Change Controller: IETF
- Specification Document(s): Section 6.2.1 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: BBS-PROOF
- Algorithm Description: Corresponds to a ciphersuite identifier of BBS_BLS12381G1_XMD:SHA-256_SSWU_RO_H2G_HM2S_
- Algorithm Usage Location(s): Presented
- JWP Implementation Requirements: Required
- Change Controller: IETF
- Specification Document(s): Section 6.2.1 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: MAC-H256
- Algorithm Description: MAC-H256 uses HMAC SHA-256 as the MAC and ECDSA using P-256 and SHA-256 for the signatures
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.3.9 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: MAC-H384
- Algorithm Description: MAC-H384 uses HMAC SHA-384 as the MAC and ECDSA using P-384 and SHA-384 for the signatures
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.3.9 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: MAC-H512
- Algorithm Description: MAC-H512 uses HMAC SHA-512 as the MAC and ECDSA using P-521 and SHA-512 for the signatures
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.3.9 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: MAC-K25519
- Algorithm Description: MAC-K25519 uses KMAC SHAKE128 as the MAC and EdDSA using Curve25519 for the signatures
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.3.9 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: MAC-K448
- Algorithm Description: MAC-K448 uses KMAC SHAKE256 as the MAC and EdDSA using Curve448 for the signatures
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.3.9 of this specification
- Algorithm Analysis Documents(s): n/a
- Algorithm Name: MAC-H256K
- Algorithm Description: MAC-H256K uses HMAC SHA-256 as the MAC and ECDSA using secp256k1 and SHA-256 for the signatures
- Algorithm Usage Location(s): Issued, Presented
- JWP Implementation Requirements: Optional
- Change Controller: IETF
- Specification Document(s): Section 6.3.9 of this specification
- Algorithm Analysis Documents(s): n/a
JSON Web Proof Header Parameters Registration
This section registers the following JWP Header Parameters in the IANA "JSON Web Proof Header Parameters" registry established by [I-D.ietf-jose-json-web-proof].
Registry Contents
Proof JWK Header Parameter
- Header Parameter Name: proof_jwk
- Header Parameter Description: Issuer's Ephemeral Key
- Header Parameter Usage Location(s): Issued
- Change Controller: IETF
- Specification Document(s): Section 6.1.5 of this specification
Presentation JWK Header Parameter
- Header Parameter Name: presentation_jwk
- Header Parameter Description: Holder's Presentation Key
- Header Parameter Usage Location(s): Issued
- Change Controller: IETF
- Specification Document(s): Section 6.1.5 of this specification
References
Normative References
Informative References
[VC-DATA-MODEL-2.0]

Verifiable Credentials Data Model 2.0
Manu Sporny
Digital Bazaar
Ted Thibodeau Jr
OpenLink Software
Ivan Herman
W3C
Michael B. Jones
Invited Expert
Gabe Cohen
Block
27 December 2023
[I-D.ietf-jose-json-web-proof]
[RFC2119]
[RFC8174]
[RFC7515]
[RFC7518]
[I-D.irtf-cfrg-bbs-signatures]
[I-D.ietf-cose-bls-key-representations]
[RFC2104]
[RFC5226]
Example JWPs
The following examples use algorithms defined in JSON Proof Algorithms and also contain the keys used, so that implementations can validate these samples.
Example Single-Use JWP
This example uses the Single-Use Algorithm as defined in JSON Proof Algorithms to create a JSON Proof Token. It demonstrates how to apply selective disclosure using an array of traditional JWS-based signatures. Unlinkability is only achieved by using each JWP one time, as multiple uses are inherently linkable via the traditional ECDSA signature embedded in the proof.
To begin, we need two asymmetric keys for Single Use: one that represents the JPT Issuer's stable key and the other is an ephemeral key generated by the Issuer just for this JWP.
This is the Issuer's stable private key used in this example in the JWK format:
Issuer Private Key (es256)
{
  "kty": "EC",
  "crv": "P-256",
  "x": "NotxMq_Rr_ErV50eOH-lGInz0hi_nTppqnryBf8kzX0",
  "y": "5fOHIjkB1zdIXaiLv_7Jz4nQW9z_WyKVuw2LHzb6ruA",
  "d": "TLkBMKah0Bn7eF5ywRESj7AD6llMXOE0bm8z90kiy-Q"
}

This is the ephemeral private key used in this example in the JWK format:
Issuer Ephemeral Private Key (es256)
{
  "kty": "EC",
  "crv": "P-256",
  "x": "D9VKlceRGXfY9HARAjTS2MVONVPjNs0CVAY3em66ah4",
  "y": "1JGV_YDm9Dm2C3GfZ6v-B-rxNvTXzuxaZ3xL472y3QQ",
  "d": "ntBMIMIHPffjmvWL1XSW3bG624Np3qSfGu0K6SPetqg"
}

This is the Holder's presentation private key used in this example in the JWK format:
Holder Presentation Private Key
{
  "kty": "EC",
  "crv": "P-256",
  "x": "22jalD_MobRDcYln86LyMw8ErJ2xVmfpid0wsM-MxWI",
  "y": "x0ftA-3LWdiZdoLjFnPzzh5cHi8QWLm3MBCvJJHdzPU",
  "d": "gOeWaP6lPkz20Fb_ScyLv_Nhrh7KSM34HCR3nQSSiKc"
}

The JWP Protected Header declares that the data structure is a JPT and the JWP Proof Input is secured using the Single-Use ECDSA algorithm with the P-256 curve and SHA-256 digest. It also includes the ephemeral public key, the Holder's presentation public key and list of claims used for this JPT.
Issuer Protected header (es256)
{
  "alg": "SU-ES256",
  "typ": "JPT",
  "iss": "https://issuer.example",
  "claims": [
    "iat",
    "exp",
    "family_name",
    "given_name",
    "email",
    "address",
    "age_over_21"
  ],
  "proof_jwk": {
    "kty": "EC",
    "crv": "P-256",
    "x": "D9VKlceRGXfY9HARAjTS2MVONVPjNs0CVAY3em66ah4",
    "y": "1JGV_YDm9Dm2C3GfZ6v-B-rxNvTXzuxaZ3xL472y3QQ",
    "d": "ntBMIMIHPffjmvWL1XSW3bG624Np3qSfGu0K6SPetqg"
  },
  "presentation_jwk": {
    "kty": "EC",
    "crv": "P-256",
    "x": "22jalD_MobRDcYln86LyMw8ErJ2xVmfpid0wsM-MxWI",
    "y": "x0ftA-3LWdiZdoLjFnPzzh5cHi8QWLm3MBCvJJHdzPU",
    "d": "gOeWaP6lPkz20Fb_ScyLv_Nhrh7KSM34HCR3nQSSiKc"
  }
}

The JWP Protected Header JSON is serialized (without the above whitespace added for readability) and uses UTF-8 encoding to convert into an octet string. This gives:
Encoded Issuer Protected Header (es256, base64url-encoded)
eyJhbGciOiJTVS1FUzI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBzOi8vaXNzdWVyL
mV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hbWUiLCJnaXZlbl
9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicHJvb2ZfandrIjp
7Imt0eSI6IkVDIiwiY3J2IjoiUC0yNTYiLCJ4IjoiRDlWS2xjZVJHWGZZOUhBUkFqVFMy
TVZPTlZQak5zMENWQVkzZW02NmFoNCIsInkiOiIxSkdWX1lEbTlEbTJDM0dmWjZ2LUItc
nhOdlRYenV4YVozeEw0NzJ5M1FRIiwiZCI6Im50Qk1JTUlIUGZmam12V0wxWFNXM2JHNj
I0TnAzcVNmR3UwSzZTUGV0cWcifSwicHJlc2VudGF0aW9uX2p3ayI6eyJrdHkiOiJFQyI
sImNydiI6IlAtMjU2IiwieCI6IjIyamFsRF9Nb2JSRGNZbG44Nkx5TXc4RXJKMnhWbWZw
aWQwd3NNLU14V0kiLCJ5IjoieDBmdEEtM0xXZGlaZG9MakZuUHp6aDVjSGk4UVdMbTNNQ
kN2SkpIZHpQVSIsImQiOiJnT2VXYVA2bFBrejIwRmJfU2N5THZfTmhyaDdLU00zNEhDUj
NuUVNTaUtjIn19

The Single Use algorithm utilizes multiple individual JWS Signatures. Each signature value is generated by creating a JWS with a single Protected Header with the associated alg value. In this example, the fixed header used for each JWS is the serialized JSON Object {"alg":"ES256"}. This protected header will be used to generate a signature over each corresponding payload in the JWP. The corresponding octet value in the proof is the octet string (base64url-decoded) value of the signature.
The final proof value from the Issuer is an array with the octets of the header signature, followed by entries for each payload signature.
The resulting JSON serialized JPT using the above examples is:
Issued JWP in JSON Serialization (es256)
{
  "issuer": "eyJhbGciOiJTVS1FUzI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBz
       Oi8vaXNzdWVyLmV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaW
       x5X25hbWUiLCJnaXZlbl9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292
       ZXJfMjEiXSwicHJvb2ZfandrIjp7Imt0eSI6IkVDIiwiY3J2IjoiUC0yNTYiLC
       J4IjoiRDlWS2xjZVJHWGZZOUhBUkFqVFMyTVZPTlZQak5zMENWQVkzZW02NmFo
       NCIsInkiOiIxSkdWX1lEbTlEbTJDM0dmWjZ2LUItcnhOdlRYenV4YVozeEw0Nz
       J5M1FRIiwiZCI6Im50Qk1JTUlIUGZmam12V0wxWFNXM2JHNjI0TnAzcVNmR3Uw
       SzZTUGV0cWcifSwicHJlc2VudGF0aW9uX2p3ayI6eyJrdHkiOiJFQyIsImNydi
       I6IlAtMjU2IiwieCI6IjIyamFsRF9Nb2JSRGNZbG44Nkx5TXc4RXJKMnhWbWZw
       aWQwd3NNLU14V0kiLCJ5IjoieDBmdEEtM0xXZGlaZG9MakZuUHp6aDVjSGk4UV
       dMbTNNQkN2SkpIZHpQVSIsImQiOiJnT2VXYVA2bFBrejIwRmJfU2N5THZfTmhy
       aDdLU00zNEhDUjNuUVNTaUtjIn19",
  "payloads": [
    "MTcxNDUyMTYwMA",
    "MTcxNzE5OTk5OQ",
    "IkRvZSI",
    "IkpheSI",
    "ImpheWRvZUBleGFtcGxlLm9yZyI",
    "eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5Bbnl0b3duLCBDQSAxMjM0NVxu
       VVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4gU3QuIiwibG9jYWxpdH
       kiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZSI6MTIzNDUs
       ImNvdW50cnkiOiJVU0EifQ",
    "dHJ1ZQ"
  ],
  "proof": [
    "CHo9PJ5DS6hE7c76e2OmYqupaz5wd6l4W22dDAaOaZhwslkYfyU1WAuqWYk8aH9T
       i_3YvYDoBaucEx3zFZ93rA",
    "qE_Gz8lFI0OhETt91QYxz_73ilylhujT7AILjvyPP1Ej1A0BkP9zmaK2Sk3MYrD5
       edpSK6qXVwaD1Ohs2tOoCg",
    "_EX3WWACsKxDftbvHoz284heDHcfxZCB9HiJXF9GNOXUuMJ3LDOdoiePfQuuYKVd
       EOjLrguzr96nP_cJECHCyg",
    "b5PJ3zCmUG7AsOThbLZgqPTl9Cbmn2CSd3oFHgn1M-Rb9ApjAMxXSonvGYLAowL0
       E2oGO5FEFx8JG6n5tFPeCw",
    "GywIaipvbLVo2W0cbrtENLYSK4EXm9iV_AqaEnx7yjhooc1MJFccnJgCf8Rs43IJ
       F0sYxpxFMp0lht3wuYSNlQ",
    "8xsCP7g8DX7iv_TGoyAUcpk_-RBcdEm9KBjTxp1jLnHzHotSZAhfrTa-xnhOBkp4
       GoJOt3vVciD0PiuYdYvjjw",
    "QXh_BrOv6HBjUD_R9hIrHEHtZNftCR2sBdfN1VJAXFxGxdxbX1xAL_tMLSkceQu3
       Wrvcpyvsti4Po75XGAgIIA",
    "N3xPaLGnlmdQnokJZSKjffnXC4t4ZNCiXdvpgeMuNd5O0FbwQb8ZFZNFzASMfmmX
       Hll2oR5IQyiP2PIIaNsxbQ"
  ]
}

The compact serialization of the same JPT is:
Issued JWP in Compact Serialization (es256)
eyJhbGciOiJTVS1FUzI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBzOi8vaXNzdWVyL
mV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hbWUiLCJnaXZlbl
9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicHJvb2ZfandrIjp
7Imt0eSI6IkVDIiwiY3J2IjoiUC0yNTYiLCJ4IjoiRDlWS2xjZVJHWGZZOUhBUkFqVFMy
TVZPTlZQak5zMENWQVkzZW02NmFoNCIsInkiOiIxSkdWX1lEbTlEbTJDM0dmWjZ2LUItc
nhOdlRYenV4YVozeEw0NzJ5M1FRIiwiZCI6Im50Qk1JTUlIUGZmam12V0wxWFNXM2JHNj
I0TnAzcVNmR3UwSzZTUGV0cWcifSwicHJlc2VudGF0aW9uX2p3ayI6eyJrdHkiOiJFQyI
sImNydiI6IlAtMjU2IiwieCI6IjIyamFsRF9Nb2JSRGNZbG44Nkx5TXc4RXJKMnhWbWZw
aWQwd3NNLU14V0kiLCJ5IjoieDBmdEEtM0xXZGlaZG9MakZuUHp6aDVjSGk4UVdMbTNNQ
kN2SkpIZHpQVSIsImQiOiJnT2VXYVA2bFBrejIwRmJfU2N5THZfTmhyaDdLU00zNEhDUj
NuUVNTaUtjIn19.MTcxNDUyMTYwMA~MTcxNzE5OTk5OQ~IkRvZSI~IkpheSI~ImpheWRv
ZUBleGFtcGxlLm9yZyI~eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5Bbnl0b3duL
CBDQSAxMjM0NVxuVVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4gU3QuIiwibG
9jYWxpdHkiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZSI6MTIzNDU
sImNvdW50cnkiOiJVU0EifQ~dHJ1ZQ.CHo9PJ5DS6hE7c76e2OmYqupaz5wd6l4W22dDA
aOaZhwslkYfyU1WAuqWYk8aH9Ti_3YvYDoBaucEx3zFZ93rA~qE_Gz8lFI0OhETt91QYx
z_73ilylhujT7AILjvyPP1Ej1A0BkP9zmaK2Sk3MYrD5edpSK6qXVwaD1Ohs2tOoCg~_E
X3WWACsKxDftbvHoz284heDHcfxZCB9HiJXF9GNOXUuMJ3LDOdoiePfQuuYKVdEOjLrgu
zr96nP_cJECHCyg~b5PJ3zCmUG7AsOThbLZgqPTl9Cbmn2CSd3oFHgn1M-Rb9ApjAMxXS
onvGYLAowL0E2oGO5FEFx8JG6n5tFPeCw~GywIaipvbLVo2W0cbrtENLYSK4EXm9iV_Aq
aEnx7yjhooc1MJFccnJgCf8Rs43IJF0sYxpxFMp0lht3wuYSNlQ~8xsCP7g8DX7iv_TGo
yAUcpk_-RBcdEm9KBjTxp1jLnHzHotSZAhfrTa-xnhOBkp4GoJOt3vVciD0PiuYdYvjjw
~QXh_BrOv6HBjUD_R9hIrHEHtZNftCR2sBdfN1VJAXFxGxdxbX1xAL_tMLSkceQu3Wrvc
pyvsti4Po75XGAgIIA~N3xPaLGnlmdQnokJZSKjffnXC4t4ZNCiXdvpgeMuNd5O0FbwQb
8ZFZNFzASMfmmXHll2oR5IQyiP2PIIaNsxbQ

To present this JPT, we first use the following presentation header with a nonce (provided by the Verifier):
Presentation Header
{
  "alg": "SU-ES256",
  "aud": "https://recipient.example.com",
  "nonce": "5bWkqdXm17RmpJsXB4ccFoLIC1SS1qeNLC39mssNJww"
}

This header is serialized without whitespace and UTF-8 encoded into an octet string. This gives:
Presentation Header (base64url-encoded)
eyJhbGciOiJTVS1FUzI1NiIsImF1ZCI6Imh0dHBzOi8vcmVjaXBpZW50LmV4YW1wbGUuY
29tIiwibm9uY2UiOiI1YldrcWRYbTE3Um1wSnNYQjRjY0ZvTElDMVNTMXFlTkxDMzltc3
NOSnd3In0

When signed with the holder's presentation key, the resulting signature are:
s5x70bOGJAMeZlA0zM2RYN8u2fGG5nTqLSt1cLFpNJbEwr56YlRS7TIoEGMDx0rP6nPxY
iGXoQy-a7-A3piokQ

Figure: Holder Proof-of-Possession (base64url-encoded)
Then by applying selective disclosure of only the given name and age claims (family name and email hidden), we get the following presented JPT:
{
  "presentation": "eyJhbGciOiJTVS1FUzI1NiIsImF1ZCI6Imh0dHBzOi8vcmVjaX
       BpZW50LmV4YW1wbGUuY29tIiwibm9uY2UiOiI1YldrcWRYbTE3Um1wSnNYQjRj
       Y0ZvTElDMVNTMXFlTkxDMzltc3NOSnd3In0",
  "issuer": "eyJhbGciOiJTVS1FUzI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBz
       Oi8vaXNzdWVyLmV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaW
       x5X25hbWUiLCJnaXZlbl9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292
       ZXJfMjEiXSwicHJvb2ZfandrIjp7Imt0eSI6IkVDIiwiY3J2IjoiUC0yNTYiLC
       J4IjoiRDlWS2xjZVJHWGZZOUhBUkFqVFMyTVZPTlZQak5zMENWQVkzZW02NmFo
       NCIsInkiOiIxSkdWX1lEbTlEbTJDM0dmWjZ2LUItcnhOdlRYenV4YVozeEw0Nz
       J5M1FRIiwiZCI6Im50Qk1JTUlIUGZmam12V0wxWFNXM2JHNjI0TnAzcVNmR3Uw
       SzZTUGV0cWcifSwicHJlc2VudGF0aW9uX2p3ayI6eyJrdHkiOiJFQyIsImNydi
       I6IlAtMjU2IiwieCI6IjIyamFsRF9Nb2JSRGNZbG44Nkx5TXc4RXJKMnhWbWZw
       aWQwd3NNLU14V0kiLCJ5IjoieDBmdEEtM0xXZGlaZG9MakZuUHp6aDVjSGk4UV
       dMbTNNQkN2SkpIZHpQVSIsImQiOiJnT2VXYVA2bFBrejIwRmJfU2N5THZfTmhy
       aDdLU00zNEhDUjNuUVNTaUtjIn19",
  "payloads": [
    "MTcxNDUyMTYwMA",
    "MTcxNzE5OTk5OQ",
    "IkRvZSI",
    "IkpheSI",
    "ImpheWRvZUBleGFtcGxlLm9yZyI",
    "eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5Bbnl0b3duLCBDQSAxMjM0NVxu
       VVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4gU3QuIiwibG9jYWxpdH
       kiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZSI6MTIzNDUs
       ImNvdW50cnkiOiJVU0EifQ",
    "dHJ1ZQ",
    null,
    null
  ],
  "proof": [
    "CHo9PJ5DS6hE7c76e2OmYqupaz5wd6l4W22dDAaOaZhwslkYfyU1WAuqWYk8aH9T
       i_3YvYDoBaucEx3zFZ93rA",
    "s5x70bOGJAMeZlA0zM2RYN8u2fGG5nTqLSt1cLFpNJbEwr56YlRS7TIoEGMDx0rP
       6nPxYiGXoQy-a7-A3piokQ",
    "qE_Gz8lFI0OhETt91QYxz_73ilylhujT7AILjvyPP1Ej1A0BkP9zmaK2Sk3MYrD5
       edpSK6qXVwaD1Ohs2tOoCg",
    "_EX3WWACsKxDftbvHoz284heDHcfxZCB9HiJXF9GNOXUuMJ3LDOdoiePfQuuYKVd
       EOjLrguzr96nP_cJECHCyg",
    "b5PJ3zCmUG7AsOThbLZgqPTl9Cbmn2CSd3oFHgn1M-Rb9ApjAMxXSonvGYLAowL0
       E2oGO5FEFx8JG6n5tFPeCw",
    "GywIaipvbLVo2W0cbrtENLYSK4EXm9iV_AqaEnx7yjhooc1MJFccnJgCf8Rs43IJ
       F0sYxpxFMp0lht3wuYSNlQ",
    "8xsCP7g8DX7iv_TGoyAUcpk_-RBcdEm9KBjTxp1jLnHzHotSZAhfrTa-xnhOBkp4
       GoJOt3vVciD0PiuYdYvjjw"
  ]
}

Figure: Final Presentation in JSON Serialization
And also in compact serialization:
eyJhbGciOiJTVS1FUzI1NiIsImF1ZCI6Imh0dHBzOi8vcmVjaXBpZW50LmV4YW1wbGUuY
29tIiwibm9uY2UiOiI1YldrcWRYbTE3Um1wSnNYQjRjY0ZvTElDMVNTMXFlTkxDMzltc3
NOSnd3In0.eyJhbGciOiJTVS1FUzI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBzOi8
vaXNzdWVyLmV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hbWUi
LCJnaXZlbl9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicHJvb
2ZfandrIjp7Imt0eSI6IkVDIiwiY3J2IjoiUC0yNTYiLCJ4IjoiRDlWS2xjZVJHWGZZOU
hBUkFqVFMyTVZPTlZQak5zMENWQVkzZW02NmFoNCIsInkiOiIxSkdWX1lEbTlEbTJDM0d
mWjZ2LUItcnhOdlRYenV4YVozeEw0NzJ5M1FRIiwiZCI6Im50Qk1JTUlIUGZmam12V0wx
WFNXM2JHNjI0TnAzcVNmR3UwSzZTUGV0cWcifSwicHJlc2VudGF0aW9uX2p3ayI6eyJrd
HkiOiJFQyIsImNydiI6IlAtMjU2IiwieCI6IjIyamFsRF9Nb2JSRGNZbG44Nkx5TXc4RX
JKMnhWbWZwaWQwd3NNLU14V0kiLCJ5IjoieDBmdEEtM0xXZGlaZG9MakZuUHp6aDVjSGk
4UVdMbTNNQkN2SkpIZHpQVSIsImQiOiJnT2VXYVA2bFBrejIwRmJfU2N5THZfTmhyaDdL
U00zNEhDUjNuUVNTaUtjIn19.MTcxNDUyMTYwMA~MTcxNzE5OTk5OQ~IkRvZSI~IkpheS
I~ImpheWRvZUBleGFtcGxlLm9yZyI~eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5
Bbnl0b3duLCBDQSAxMjM0NVxuVVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4g
U3QuIiwibG9jYWxpdHkiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZ
SI6MTIzNDUsImNvdW50cnkiOiJVU0EifQ~dHJ1ZQ~~.CHo9PJ5DS6hE7c76e2OmYqupaz
5wd6l4W22dDAaOaZhwslkYfyU1WAuqWYk8aH9Ti_3YvYDoBaucEx3zFZ93rA~s5x70bOG
JAMeZlA0zM2RYN8u2fGG5nTqLSt1cLFpNJbEwr56YlRS7TIoEGMDx0rP6nPxYiGXoQy-a
7-A3piokQ~qE_Gz8lFI0OhETt91QYxz_73ilylhujT7AILjvyPP1Ej1A0BkP9zmaK2Sk3
MYrD5edpSK6qXVwaD1Ohs2tOoCg~_EX3WWACsKxDftbvHoz284heDHcfxZCB9HiJXF9GN
OXUuMJ3LDOdoiePfQuuYKVdEOjLrguzr96nP_cJECHCyg~b5PJ3zCmUG7AsOThbLZgqPT
l9Cbmn2CSd3oFHgn1M-Rb9ApjAMxXSonvGYLAowL0E2oGO5FEFx8JG6n5tFPeCw~GywIa
ipvbLVo2W0cbrtENLYSK4EXm9iV_AqaEnx7yjhooc1MJFccnJgCf8Rs43IJF0sYxpxFMp
0lht3wuYSNlQ~8xsCP7g8DX7iv_TGoyAUcpk_-RBcdEm9KBjTxp1jLnHzHotSZAhfrTa-
xnhOBkp4GoJOt3vVciD0PiuYdYvjjw

Figure: Final Presentation in Compact Serialization
Example BBS JWP
The following example uses the BBS algorithm.
This is the Issuer's stable private key in the JWK format:
BBS private key in JWK format
{
  "kty": "EC2",
  "alg": "BBS",
  "use": "proof",
  "crv": "BLS12381G2",
  "x": "C79lnPbZtsIGtqBuf1rzr8lY3Bbd_BOE1Bh6rKWXqK4qKEz_fUXecShoniDuz
       p9SBrK-bBGA1KNC6ped74O1r4320WLGTqKyEtEfpuPi81YLx_09eB-ue1_0H2U
       Uv4wz",
  "y": "CufkmneMEP4ZM08Ql_Yq_L2NGi6wwRgD9ytCiCRHz8SAx-avaw-aNSj7idiNC
       yC1ChoPSNo4OGM4Ra8KJyEh9sSPxx_IpLGzoL3OCrsYkdk4gyZXSMcZYFmVh1c
       bwci4",
  "d": "EUPE3yEmoCeXdDaft-19bhP4t_kyLgyYH-kkP2dnEgc"
}

There is no additional holder key necessary for presentation proofs.
For the following protected header and array of payloads:
Example issuer protected header
{
  "kid": "HjfcpyjuZQ-O8Ye2hQnNbT9RbbnrobptdnExR0DUjU8",
  "alg": "BBS"
}

Example issuer payloads (as members of a JSON array)
[
    1714521600,
    1717199999,
    "Doe",
    "Jay",
    "jaydoe@example.org",
    {
        "formatted": "1234 Main St.\nAnytown, CA 12345\nUSA",
        "street_address": "1234 Main St.",
        "locality": "Anytown",
        "region": "CA",
        "postal_code": 12345,
        "country": "USA"
    },
    true
]

These components are signed using the private issuer key previously given, which is then representable in the following serializations:
Issued JWP (JSON serialization)
{
  "issuer": "eyJraWQiOiJIamZjcHlqdVpRLU84WWUyaFFuTmJUOVJiYm5yb2JwdGRu
       RXhSMERValU4IiwiYWxnIjoiQkJTIn0",
  "payloads": [
    "MTcxNDUyMTYwMA",
    "MTcxNzE5OTk5OQ",
    "IkRvZSI",
    "IkpheSI",
    "ImpheWRvZUBleGFtcGxlLm9yZyI",
    "eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5Bbnl0b3duLCBDQSAxMjM0NVxu
       VVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4gU3QuIiwibG9jYWxpdH
       kiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZSI6MTIzNDUs
       ImNvdW50cnkiOiJVU0EifQ",
    "dHJ1ZQ"
  ],
  "proof": [
    "l65vrd4YAT1XXTp_qn3ZawIaW4catOywZuKoECaX8QKzU7ccIOQBwmG0WoHN5kAs
       FSwgN6M2HjUS7ILNqDZF6k2TB0kNs2KBWQi6fjSsPP4"
  ]
}

Issued JWP (compact serialization)
eyJraWQiOiJIamZjcHlqdVpRLU84WWUyaFFuTmJUOVJiYm5yb2JwdGRuRXhSMERValU4I
iwiYWxnIjoiQkJTIn0.MTcxNDUyMTYwMA~MTcxNzE5OTk5OQ~IkRvZSI~IkpheSI~Imph
eWRvZUBleGFtcGxlLm9yZyI~eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5Bbnl0b
3duLCBDQSAxMjM0NVxuVVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4gU3QuIi
wibG9jYWxpdHkiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZSI6MTI
zNDUsImNvdW50cnkiOiJVU0EifQ~dHJ1ZQ.l65vrd4YAT1XXTp_qn3ZawIaW4catOywZu
KoECaX8QKzU7ccIOQBwmG0WoHN5kAsFSwgN6M2HjUS7ILNqDZF6k2TB0kNs2KBWQi6fjS
sPP4

For a presentation with the following presentation header:
Holder Presentation Header
{
    "alg": "BBS-PROOF",
    "aud": "https://recipient.example.com",
    "nonce": "wrmBRkKtXjQ"
}

The holder decides to share all information other than the email address, and generates a proof. That proof is represented in the following serializations:
Presentation JWP (JSON serialization)
{
  "presentation": "eyJhbGciOiJCQlMtUFJPT0YiLCJhdWQiOiJodHRwczovL3JlY2
       lwaWVudC5leGFtcGxlLmNvbSIsIm5vbmNlIjoid3JtQlJrS3RYalEifQ",
  "issuer": "eyJraWQiOiJIamZjcHlqdVpRLU84WWUyaFFuTmJUOVJiYm5yb2JwdGRu
       RXhSMERValU4IiwiYWxnIjoiQkJTIn0",
  "payloads": [
    "MTcxNDUyMTYwMA",
    "MTcxNzE5OTk5OQ",
    "IkRvZSI",
    "IkpheSI",
    null,
    null,
    null
  ],
  "proof": [
    "g83fhTbW8QkS0YwTXn97pUpMyuRm5Xr12RlXyTBY8grD_gGz2auCJc4BgKLkM9TN
       pV0qy7ZBtEYAh5p8NppDvfN23bFQJD5WwrCIUp9SqyJiZGk2YRkOXI7pvgZZ5I
       48sB5gmJgizGXOHaGVZ_IZ4QxQ65WOXQtwv4VVrASA2HQplZ4pfdke7j5aUT8D
       tt0yXp2ivia-q1lEJ-yD9yBjn0KTvOv4ig6_SkI1tRrRZyQzcMIpMq2rdWj4rQ
       MC2yxLJE0QH603rnQUXoV4F9fLxVOWRsIy9nrK9aLzvW4DAiLgoQ3ccYzL2cO_
       bbAg47zxZN8YPsiVz6rHVzy7fKAZ7jlejPHqM31-K0qxn5002wIz40g7ejVHPM
       crI5Aw2ezMcuy9ZLu16YCQEJMqyFlLwVbf-912pPrMFWPIgFRKZMkv2o55K38j
       mkpLxaD4EJNZGhw4J1THOD2FeZCKpCUGFTR25fOroJ2T2cxf1nPnKyE"
  ]
}

Presentation JWP (compact serialization)
eyJhbGciOiJCQlMtUFJPT0YiLCJhdWQiOiJodHRwczovL3JlY2lwaWVudC5leGFtcGxlL
mNvbSIsIm5vbmNlIjoid3JtQlJrS3RYalEifQ.eyJraWQiOiJIamZjcHlqdVpRLU84WWU
yaFFuTmJUOVJiYm5yb2JwdGRuRXhSMERValU4IiwiYWxnIjoiQkJTIn0.MTcxNDUyMTYw
MA~MTcxNzE5OTk5OQ~IkRvZSI~IkpheSI~~~.g83fhTbW8QkS0YwTXn97pUpMyuRm5Xr1
2RlXyTBY8grD_gGz2auCJc4BgKLkM9TNpV0qy7ZBtEYAh5p8NppDvfN23bFQJD5WwrCIU
p9SqyJiZGk2YRkOXI7pvgZZ5I48sB5gmJgizGXOHaGVZ_IZ4QxQ65WOXQtwv4VVrASA2H
QplZ4pfdke7j5aUT8Dtt0yXp2ivia-q1lEJ-yD9yBjn0KTvOv4ig6_SkI1tRrRZyQzcMI
pMq2rdWj4rQMC2yxLJE0QH603rnQUXoV4F9fLxVOWRsIy9nrK9aLzvW4DAiLgoQ3ccYzL
2cO_bbAg47zxZN8YPsiVz6rHVzy7fKAZ7jlejPHqM31-K0qxn5002wIz40g7ejVHPMcrI
5Aw2ezMcuy9ZLu16YCQEJMqyFlLwVbf-912pPrMFWPIgFRKZMkv2o55K38jmkpLxaD4EJ
NZGhw4J1THOD2FeZCKpCUGFTR25fOroJ2T2cxf1nPnKyE

Example MAC JWP
The following example uses the MAC-H256 algorithm.
This is the Issuer's stable private key in the JWK format:
Issuer private key
{
  "kty": "EC",
  "crv": "P-256",
  "x": "NotxMq_Rr_ErV50eOH-lGInz0hi_nTppqnryBf8kzX0",
  "y": "5fOHIjkB1zdIXaiLv_7Jz4nQW9z_WyKVuw2LHzb6ruA",
  "d": "TLkBMKah0Bn7eF5ywRESj7AD6llMXOE0bm8z90kiy-Q"
}

This is the Issuer's ephemerally generated shared secret:
Shared Secret
"tOQLDpsc-GBL_SCG03bs9cesAr-hPfBhX4xzcNgjMkg"

This is the Holder's presentation private key in the JWK format:
Holder private key
{
  "kty": "EC",
  "crv": "P-256",
  "x": "22jalD_MobRDcYln86LyMw8ErJ2xVmfpid0wsM-MxWI",
  "y": "x0ftA-3LWdiZdoLjFnPzzh5cHi8QWLm3MBCvJJHdzPU",
  "d": "gOeWaP6lPkz20Fb_ScyLv_Nhrh7KSM34HCR3nQSSiKc"
}

For the following protected header and array of payloads:
Example issuer protected header
{
  "alg": "MAC-H256",
  "typ": "JPT",
  "iss": "https://issuer.example",
  "claims": [
    "iat",
    "exp",
    "family_name",
    "given_name",
    "email",
    "address",
    "age_over_21"
  ],
  "pjwk": {
    "kty": "EC",
    "crv": "P-256",
    "use": "sign",
    "x": "22jalD_MobRDcYln86LyMw8ErJ2xVmfpid0wsM-MxWI",
    "y": "x0ftA-3LWdiZdoLjFnPzzh5cHi8QWLm3MBCvJJHdzPU"
  }
}

Example issuer payloads (as members of a JSON array)
[
    1714521600,
    1717199999,
    "Doe",
    "Jay",
    "jaydoe@example.org",
    {
        "formatted": "1234 Main St.\nAnytown, CA 12345\nUSA",
        "street_address": "1234 Main St.",
        "locality": "Anytown",
        "region": "CA",
        "postal_code": 12345,
        "country": "USA"
    },
    true
]

The first MAC is generated using the key issuer_header and a value of the issuer protected header as a UTF-8 encoded octet string. This results in the following MAC:
Issuer MAC of protected header (base64url-encoded)
TOjZ36o6iPWIdsaeA0yxy3L9DIzntXX2LAJjXwnSZkg

The issuer generates an array of derived keys with one for each payload by using the shared secret as the key, and the index of the payload (as payload_{n} in UTF-8 encoded octets) as the input in a HMAC operation. This results in the following set of derived keys:
Derived payload keys (base64url-encoded)
[
  "GAn9DhyGOZB0PlE2PudipP3aKNTA_gD11g7qiiRu32Y",
  "Yrx6S56TmoboAC-dLLm6Zvy1G3zA9DGrUHCQTHy5mTA",
  "zNHvKK5SvoWTUXvsO1S3rn-Yy2BSlvroNZeoRioh1jk",
  "n-udTDYC1OaVC36--jGHXpeRG2Iq0_notn_33W7FeNg",
  "BOpCyb5PUWIUqG-2KUju0db1FDUJuzvcR3gadtmUYjM",
  "1x6J0zHDO87LXk1E_ydE57Lof0CjqrDwBpcqJwuTQKY",
  "I5EFCW5G4Yxsbr3wjCBQKOTUSS_K1i1Dys6LUvsysqc"
]

A MAC is generated for each payload using the corresponding derived payload key. This results in the following set of MAC values:
Payload MAC values (base64url-encoded)
[
  "6O-9nDWmT57ollhyEbUT_lVCQl9t4UED4RQ93jDcnvQ",
  "ouqfAlBrqW9MNmq8OsG-DvlvkhpzqloWWYAT-FzBd00",
  "RJKlT-6xZJ1-A8XLpQzheNw5yCkucroo7S9unnzqt4U",
  "LG4tOP_y9gyRVXNiONWJttaILyql8yXPzx2uJCAefA0",
  "0CUaeOR7Cj716MnJQTRtUqEcDzChvx3Q5EXEju9xZbE",
  "LROkQva5N4SMEjUWAhEOPeKoEt0-djABh1PXkvQcUKw",
  "J8LZ-gP9P9xTIlSSZrVS__KgZ0u7J1bkT8W_wwuJpVA"
]

The issuer protected header MAC and the payload MAC octet strings are concatenated into a single value known as the combined MAC representation. This representation is signed with the issuer's private key.
The proof consists of two octet string values: the signature over the combined MAC representation, and the shared secret.
Issued Proof (base64url-encoded)
[
  "nuUd_VYBEWTZa3PqTAIy6olbgspxSHZ7dx6qq7qO8PaSM_756ik_-qvRH8hf9jAfCt
o95AOOpsifUP2bgRIw3A",
  "jrCqKEgKg3qRpCEfK3VFQvz8hQT1joMq8FBGejmKlUg"
]

The final issued JWP in JSON serialization is:
Issued JWP (in JSON serialization)
{
  "issuer": "eyJhbGciOiJNQUMtSDI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBz
Oi8vaXNzdWVyLmV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hb
WUiLCJnaXZlbl9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicG
p3ayI6eyJrdHkiOiJFQyIsImNydiI6IlAtMjU2IiwidXNlIjoic2lnbiIsIngiOiIyMmp
hbERfTW9iUkRjWWxuODZMeU13OEVySjJ4Vm1mcGlkMHdzTS1NeFdJIiwieSI6IngwZnRB
LTNMV2RpWmRvTGpGblB6emg1Y0hpOFFXTG0zTUJDdkpKSGR6UFUifX0",
  "payloads": [
    "MTcxNDUyMTYwMA",
    "MTcxNzE5OTk5OQ",
    "IkRvZSI",
    "IkpheSI",
    "ImpheWRvZUBleGFtcGxlLm9yZyI",
    "eyJmb3JtYXR0ZWQiOiIxMjM0IE1haW4gU3QuXG5Bbnl0b3duLCBDQSAxMjM0NVxu
VVNBIiwic3RyZWV0X2FkZHJlc3MiOiIxMjM0IE1haW4gU3QuIiwibG9jYWxpdHkiOiJBb
nl0b3duIiwicmVnaW9uIjoiQ0EiLCJwb3N0YWxfY29kZSI6MTIzNDUsImNvdW50cnkiOi
JVU0EifQ",
    "dHJ1ZQ"
  ],
  "proof": [
    "nuUd_VYBEWTZa3PqTAIy6olbgspxSHZ7dx6qq7qO8PaSM_756ik_-qvRH8hf9jAf
Cto95AOOpsifUP2bgRIw3A",
    "jrCqKEgKg3qRpCEfK3VFQvz8hQT1joMq8FBGejmKlUg"
  ]
}

The same JWP in compact serialization:
Issued JWP (in compact serialization)
eyJhbGciOiJNQUMtSDI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBzOi8vaXNzdWVyL
mV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hbWUiLCJnaXZlbl
9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicGp3ayI6eyJrdHk
iOiJFQyIsImNydiI6IlAtMjU2IiwidXNlIjoic2lnbiIsIngiOiIyMmphbERfTW9iUkRj
WWxuODZMeU13OEVySjJ4Vm1mcGlkMHdzTS1NeFdJIiwieSI6IngwZnRBLTNMV2RpWmRvT
GpGblB6emg1Y0hpOFFXTG0zTUJDdkpKSGR6UFUifX0.MTcxNDUyMTYwMA~MTcxNzE5OTk
5OQ~IkRvZSI~IkpheSI~ImpheWRvZUBleGFtcGxlLm9yZyI~eyJmb3JtYXR0ZWQiOiIxM
jM0IE1haW4gU3QuXG5Bbnl0b3duLCBDQSAxMjM0NVxuVVNBIiwic3RyZWV0X2FkZHJlc3
MiOiIxMjM0IE1haW4gU3QuIiwibG9jYWxpdHkiOiJBbnl0b3duIiwicmVnaW9uIjoiQ0E
iLCJwb3N0YWxfY29kZSI6MTIzNDUsImNvdW50cnkiOiJVU0EifQ~dHJ1ZQ.nuUd_VYBEW
TZa3PqTAIy6olbgspxSHZ7dx6qq7qO8PaSM_756ik_-qvRH8hf9jAfCto95AOOpsifUP2
bgRIw3A~jrCqKEgKg3qRpCEfK3VFQvz8hQT1joMq8FBGejmKlUg

Next, we show the presentation of the JWP with selective disclosure.
For presentation with the following presentation protected header:
Presentation Protected Header
{
  "alg": "MAC-H256",
  "aud": "https://recipient.example.com",
  "nonce": "5bWkqdXm17RmpJsXB4ccFoLIC1SS1qeNLC39mssNJww"
}

The holder will take the issuer proof (including shared secret) and derive the same individual payload MAC values (above).
In this case, the holder has decided not to disclose the last three claims provided by the issuer (corresponding to email, address, and age_over_21)
For the disclosed payloads, the holder will provide the corresponding derived key. For the non-disclosed payloads, the holder will provide the corresponding MAC value.
The final presented proof value is an array of octet strings. The contents are presentation header signature, followed by the issuer signature, then the value disclosed by the holder for each payload. This results in the following proof:
Presentation proof (base64url-encoded)
[
  "YpXhBNzi4pYyjVVSY4Y6VonVc1Gf-knK9QgNqDsrIH9oP9AsH4APRpjx_CT4zDQzhT
WeS2til2sx14AvoxR00Q",
  "nuUd_VYBEWTZa3PqTAIy6olbgspxSHZ7dx6qq7qO8PaSM_756ik_-qvRH8hf9jAfCt
o95AOOpsifUP2bgRIw3A",
  "GAn9DhyGOZB0PlE2PudipP3aKNTA_gD11g7qiiRu32Y",
  "Yrx6S56TmoboAC-dLLm6Zvy1G3zA9DGrUHCQTHy5mTA",
  "zNHvKK5SvoWTUXvsO1S3rn-Yy2BSlvroNZeoRioh1jk",
  "n-udTDYC1OaVC36--jGHXpeRG2Iq0_notn_33W7FeNg",
  "0CUaeOR7Cj716MnJQTRtUqEcDzChvx3Q5EXEju9xZbE",
  "LROkQva5N4SMEjUWAhEOPeKoEt0-djABh1PXkvQcUKw",
  "J8LZ-gP9P9xTIlSSZrVS__KgZ0u7J1bkT8W_wwuJpVA"
]

The final presented JWP in JSON serialization is:
Presented JWP (in JSON serialization)
{
  "presentation": "eyJhbGciOiJNQUMtSDI1NiIsImF1ZCI6Imh0dHBzOi8vcmVjaX
BpZW50LmV4YW1wbGUuY29tIiwibm9uY2UiOiI1YldrcWRYbTE3Um1wSnNYQjRjY0ZvTEl
DMVNTMXFlTkxDMzltc3NOSnd3In0",
  "issuer": "eyJhbGciOiJNQUMtSDI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBz
Oi8vaXNzdWVyLmV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hb
WUiLCJnaXZlbl9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicG
p3ayI6eyJrdHkiOiJFQyIsImNydiI6IlAtMjU2IiwidXNlIjoic2lnbiIsIngiOiIyMmp
hbERfTW9iUkRjWWxuODZMeU13OEVySjJ4Vm1mcGlkMHdzTS1NeFdJIiwieSI6IngwZnRB
LTNMV2RpWmRvTGpGblB6emg1Y0hpOFFXTG0zTUJDdkpKSGR6UFUifX0",
  "payloads": [
    "MTcxNDUyMTYwMA",
    "MTcxNzE5OTk5OQ",
    "IkRvZSI",
    "IkpheSI",
    null,
    null,
    null
  ],
  "proof": [
    "YpXhBNzi4pYyjVVSY4Y6VonVc1Gf-knK9QgNqDsrIH9oP9AsH4APRpjx_CT4zDQz
hTWeS2til2sx14AvoxR00Q",
    "nuUd_VYBEWTZa3PqTAIy6olbgspxSHZ7dx6qq7qO8PaSM_756ik_-qvRH8hf9jAf
Cto95AOOpsifUP2bgRIw3A",
    "GAn9DhyGOZB0PlE2PudipP3aKNTA_gD11g7qiiRu32Y",
    "Yrx6S56TmoboAC-dLLm6Zvy1G3zA9DGrUHCQTHy5mTA",
    "zNHvKK5SvoWTUXvsO1S3rn-Yy2BSlvroNZeoRioh1jk",
    "n-udTDYC1OaVC36--jGHXpeRG2Iq0_notn_33W7FeNg",
    "0CUaeOR7Cj716MnJQTRtUqEcDzChvx3Q5EXEju9xZbE",
    "LROkQva5N4SMEjUWAhEOPeKoEt0-djABh1PXkvQcUKw",
    "J8LZ-gP9P9xTIlSSZrVS__KgZ0u7J1bkT8W_wwuJpVA"
  ]
}

The same JWP in compact serialization:
Presented JWP (in compact serialization)
eyJhbGciOiJNQUMtSDI1NiIsImF1ZCI6Imh0dHBzOi8vcmVjaXBpZW50LmV4YW1wbGUuY
29tIiwibm9uY2UiOiI1YldrcWRYbTE3Um1wSnNYQjRjY0ZvTElDMVNTMXFlTkxDMzltc3
NOSnd3In0.eyJhbGciOiJNQUMtSDI1NiIsInR5cCI6IkpQVCIsImlzcyI6Imh0dHBzOi8
vaXNzdWVyLmV4YW1wbGUiLCJjbGFpbXMiOlsiaWF0IiwiZXhwIiwiZmFtaWx5X25hbWUi
LCJnaXZlbl9uYW1lIiwiZW1haWwiLCJhZGRyZXNzIiwiYWdlX292ZXJfMjEiXSwicGp3a
yI6eyJrdHkiOiJFQyIsImNydiI6IlAtMjU2IiwidXNlIjoic2lnbiIsIngiOiIyMmphbE
RfTW9iUkRjWWxuODZMeU13OEVySjJ4Vm1mcGlkMHdzTS1NeFdJIiwieSI6IngwZnRBLTN
MV2RpWmRvTGpGblB6emg1Y0hpOFFXTG0zTUJDdkpKSGR6UFUifX0.MTcxNDUyMTYwMA~M
TcxNzE5OTk5OQ~IkRvZSI~IkpheSI~~~.YpXhBNzi4pYyjVVSY4Y6VonVc1Gf-knK9QgN
qDsrIH9oP9AsH4APRpjx_CT4zDQzhTWeS2til2sx14AvoxR00Q~nuUd_VYBEWTZa3PqTA
Iy6olbgspxSHZ7dx6qq7qO8PaSM_756ik_-qvRH8hf9jAfCto95AOOpsifUP2bgRIw3A~
GAn9DhyGOZB0PlE2PudipP3aKNTA_gD11g7qiiRu32Y~Yrx6S56TmoboAC-dLLm6Zvy1G
3zA9DGrUHCQTHy5mTA~zNHvKK5SvoWTUXvsO1S3rn-Yy2BSlvroNZeoRioh1jk~n-udTD
YC1OaVC36--jGHXpeRG2Iq0_notn_33W7FeNg~0CUaeOR7Cj716MnJQTRtUqEcDzChvx3
Q5EXEju9xZbE~LROkQva5N4SMEjUWAhEOPeKoEt0-djABh1PXkvQcUKw~J8LZ-gP9P9xT
IlSSZrVS__KgZ0u7J1bkT8W_wwuJpVA

Acknowledgements
This work was incubated in the DIF Applied Cryptography Working Group.
We would like to thank Alberto Solavagione for his valuable contributions to this specification.
The BBS examples were generated using the library at https://github.com/mattrglobal/pairing_crypto .
Document History
[[ To be removed from the final specification ]]
-05
- Update of appendix describing MAC-H256 to now also be generated by the build system from a common set of code and templates.
- Update single use algorithm to use an array of octet values rather than requiring splitting an octet buffer into parts during generation of a presentation and during verification.
- Update BBS algorithm description and examples to clarify the proof is an array with a single octet string.
- Update MAC algorithm to use an array of octet values for the proof, rather than requiring splitting an octet buffer into parts.
- Add new section on the Combined MAC Representation to clarify operations are serving to recreate this octet string value.
- Correct reference to the latest BBS draft.
- SU and MAC families now use raw JWA rather than JWS and synthesized headers
- Change algorithms to not use base64url-encoding internally. Algorithms are meant to operate on octets, while base64url-encoding is used to represent those octets in JSON and compact serializations.
-04
- Refactoring figures and examples to be built from a common set across all three documents
- Move single-use example appendix from JWP to JPA
- Change algorithm from BBS-DRAFT-5 to BBS, and from BBS-PROOF-DRAFT-5 to BBS-PROOF
- Update BBS ciphersuite ID to BBS_BLS12381G1_XMD:SHA-256_SSWU_RO_
- Update to draft 5 BLS key representations
-03
- Improvements resulting from a full proofreading.
- Populated IANA Considerations section.
- Updated to use BBS draft -05.
- Updated examples.
-02
- Add new BBS-DRAFT-3 and BBS-PROOF-DRAFT-3 algorithms based on draft-irtf-cfrg-bbs-signatures-03.
- Remove prior BBS-X algorithm based on a particular implementation of earlier drafts.
-01
- Correct cross-references within group
- Describe issuer_header and presentation_header
- Update BBS references to CFRG drafts
- Rework reference to HMAC ( RFC2104 )
- Remove ZKSnark placeholder
-00
- Created initial working group draft based on draft-jmiller-jose-json-proof-algorithms-01